#version 300 es
in mediump vec2 vTex;
out lowp vec4 outColor;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 pixelSize;
uniform mediump float seconds;
uniform mediump float samples;
uniform mediump float exposure;
uniform mediump float bokehSize;
precision mediump float;

//based on a shader by XorDev

void main(void)
{
	//Initialize blur output color
	vec4 blur = vec4(0);
	
	//Total weight from all samples
	float total = 0.;
	
	//First sample offset
	float scale = bokehSize * inversesqrt(samples);

	vec2 point = vec2(scale,0);
	
	//Golden angle rotation matrix
	mat2 ang = mat2(-0.7373688, -0.6754904, 0.6754904,  -0.7373688);
	
	//Look through all the samples
	for(float i = 0.; i < samples; i++)
	{
		//Rotate point direction
		point *= ang;
		//Get sample coordinates
		vec2 uv = vTex + point*sqrt(i) * pixelSize;
		//Sample texture
        vec4 samp = texture(samplerFront, uv);
		//Add sample to total
		blur += exp(samp * exposure);
	}
	//Get sample average
	blur /= samples;
	blur.rgb = log(blur.rgb)/exposure;
	outColor = blur;
}