﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

struct ShaderParams {
	samples : f32,
	exposure : f32,
	bokehSize : f32
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%

//based on a shader by XorDev

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	var blur: vec4<f32> = vec4<f32>(0.);
	var pixelSize : vec2<f32> = c3_getPixelSize(textureFront);
	let total: f32 = 0.;
	let scale: f32 = shaderParams.bokehSize * inverseSqrt(shaderParams.samples);
	var point: vec2<f32> = vec2<f32>(scale, 0.);
	let ang: mat2x2<f32> = mat2x2<f32>(-0.7373688, -0.6754904, 0.6754904, -0.7373688);

	for (var i: f32 = 0.; i < shaderParams.samples; i += 1.) {
		point *= ang;
		let uv: vec2<f32> = input.fragUV + point * sqrt(i) * pixelSize;
		let samp: vec4<f32> = textureSample(textureFront, samplerFront, uv);
		blur += (exp(samp * shaderParams.exposure));
	}

	blur /= (shaderParams.samples);

	var output : FragmentOutput;
	output.color = log(blur) / shaderParams.exposure;
	return output;
}